<?php
/*
 * goes out and does an XMLRPC call with a piece of html containing hrefs and comes 
 * back with the same piece of html containing hrefs and image tags pointing to the
 * favicons
 */
namespace leau\co\wp_favicons_client;

if (!class_exists("XMLRPCCall")) {

	class XMLRPCCall {

		public  $_filter = 'the_content';
		
		public function __construct($moduleID, $pluginID)
		{
			/* set the new filter in the object for reference */
			$this->_filter = Config::GetModulePluginVar($moduleID, $pluginID,
					'filter_context_name');
			
			/* add a filter to the content type (which calls the server for the transformation */
			add_filter($this->_filter, array($this,'AddIcons'), 9);				
		}
		
		public function AddIcons($content)
		{
			$r_content = $content;
			if (is_string($content))
			{
				$r_content = $this->CallServerWith($content);
			}
			// $md5_content = md5($content);
			return $r_content;				
		}
		
		public function CallServerWith($content)
		{
			$uri = Config::GetOptionsArrayValue(Config::GetPluginSlug() . 'server_uri');
			$usr = Config::GetOptionsArrayValue(Config::GetPluginSlug() . 'server_usr');
			$pwd = Config::GetOptionsArrayValue(Config::GetPluginSlug() . 'server_pwd');		
			$blogid = 1; // @todo make this configurable
			$method = 'wpserver.favicon';
			
			$request = xmlrpc_encode_request($method,
				array($blogid, $usr, $pwd,
					array(
						'blog' => site_url(),
						'text' => $content
					)
				)
			);
			
			$response = wp_remote_post( $uri
				, array(
					'method' => 'POST',
					'timeout' => 45,
					'redirection' => 5,
					'httpversion' => '1.0',
					'blocking' => true,
					'headers' => array(),
					'body' => $request,
					'cookies' => array()
    			)
			);
			
			$xml = simplexml_load_string($response['body']);
			
			// echo $response['body'];
			// @todo handle alternative flows
			
			/* primary flow */
			try {
				if (!empty($xml->params->param->value->string)) {
					$content = $xml->params->param->value->string;
				}		
			} catch (Exception $e) {
				// @todo log error
			}
				
			return html_entity_decode($content);
		}		
		
	}
}